You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

240 lines
5.3 KiB

  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-3.0+
  3. # Copyright (C) 2018, Martin Kepplinger <martink@posteo.de>
  4. RED='\033[0;31m'
  5. GREEN='\033[0;32m'
  6. NC='\033[0m'
  7. set -e
  8. IFDTOOL_PATH=./util/ifdtool/ifdtool
  9. ME_CLEANER_PATH=./util/me_cleaner/me_cleaner.py
  10. have_chipname=0
  11. have_backupname=0
  12. me_clean=0
  13. lock=0
  14. have_flasher=0
  15. usage()
  16. {
  17. echo "Skulls for the X230"
  18. echo " Run this script on an external computer with a flasher"
  19. echo " connected to the X230's bottom chip (farther away from"
  20. echo " the display, closer to you)."
  21. echo ""
  22. echo "Usage: $0 [-c <chipname>] [-a] [-m] [-k <backup_filename>] [-l]"
  23. echo ""
  24. echo " -f <hardware_flasher>"
  25. echo " supported flashers: rpi, ch341a"
  26. echo ""
  27. echo " -c <chipname> flashrom chip description to use"
  28. echo " -m apply me_cleaner -S"
  29. echo " -l lock the flash instead of unlocking it"
  30. echo " -k <file> save the read image as <file>"
  31. }
  32. args=$(getopt -o f:mlc:k:h -- "$@")
  33. if [ $? -ne 0 ] ; then
  34. usage
  35. exit 1
  36. fi
  37. eval set -- "$args"
  38. while [ $# -gt 0 ]
  39. do
  40. case "$1" in
  41. -f)
  42. FLASHER=$2
  43. have_flasher=1
  44. shift
  45. ;;
  46. -m)
  47. me_clean=1
  48. ;;
  49. -l)
  50. lock=1
  51. ;;
  52. -c)
  53. CHIPNAME=$2
  54. have_chipname=1
  55. shift
  56. ;;
  57. -k)
  58. BACKUPNAME=$2
  59. have_backupname=1
  60. shift
  61. ;;
  62. -h)
  63. usage
  64. exit 1
  65. ;;
  66. --)
  67. shift
  68. break
  69. ;;
  70. *)
  71. echo "Invalid option: $1"
  72. usage
  73. exit 1
  74. ;;
  75. esac
  76. shift
  77. done
  78. command -v flashrom >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install flashrom and run as root${NC}."; exit 1; }
  79. command -v make >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install make and a C compiler${NC}."; exit 1; }
  80. if [ ! "$have_flasher" -gt 0 ] ; then
  81. echo "Skulls for the X230"
  82. echo ""
  83. echo "Please select the hardware you use:"
  84. PS3='Please select the hardware flasher: '
  85. options=("Raspberry Pi" "CH341A" "Exit")
  86. select opt in "${options[@]}"
  87. do
  88. case $opt in
  89. "Raspberry Pi")
  90. FLASHER="rpi"
  91. break
  92. ;;
  93. "CH341A")
  94. FLASHER="ch341a"
  95. break
  96. ;;
  97. "Exit")
  98. exit 0
  99. ;;
  100. *) echo invalid option;;
  101. esac
  102. done
  103. fi
  104. programmer=""
  105. if [ "${FLASHER}" = "rpi" ] ; then
  106. echo "Ok. Run this on a Rasperry Pi."
  107. programmer="linux_spi:dev=/dev/spidev0.0,spispeed=128"
  108. elif [ "${FLASHER}" = "ch341a" ] ; then
  109. echo "Ok. Connect a CH341A programmer"
  110. programmer="ch341a_spi"
  111. else
  112. echo "invalid flashrom programmer"
  113. usage
  114. exit 1
  115. fi
  116. TEMP_DIR=`mktemp -d`
  117. if [ ! "$have_chipname" -gt 0 ] ; then
  118. echo "trying to detect the chip..."
  119. flashrom -p ${programmer} &> ${TEMP_DIR}/chips || true
  120. flashrom_error=""
  121. flashrom_error=$(cat ${TEMP_DIR}/chips | grep -i error || true)
  122. if [ ! -z "${flashrom_error}" ] ; then
  123. usage
  124. echo "-------------- flashrom error: ---------------"
  125. cat ${TEMP_DIR}/chips
  126. rm -rf ${TEMP_DIR}
  127. exit 1
  128. fi
  129. CHIPNAME=""
  130. chip_found=0
  131. CHIPNAME=$(cat ${TEMP_DIR}/chips | grep Found | grep "MX25L6406E/MX25L6408E" | grep -o '".*"' || true)
  132. if [ ! -z "${CHIPNAME}" ] ; then
  133. chip_found=1
  134. fi
  135. CHIPNAME=$(cat ${TEMP_DIR}/chips | grep Found | grep "EN25QH64" | grep -o '".*"' || true)
  136. if [ ! -z "${CHIPNAME}" ] ; then
  137. chip_found=1
  138. fi
  139. if [ ! "$chip_found" -gt 0 ] ; then
  140. echo "chip not detected."
  141. flashrom -p ${programmer}
  142. rm -rf ${TEMP_DIR}
  143. echo "chip not detected. Please find it manually and rerun with the -c parameter."
  144. exit 1
  145. else
  146. echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
  147. fi
  148. fi
  149. make -C util/ifdtool
  150. if [ ! -e ${IFDTOOL_PATH} ] ; then
  151. echo "ifdtool not found at ${IFDTOOL_PATH}"
  152. exit 1
  153. fi
  154. if [ ! "$me_clean" -gt 0 ] ; then
  155. echo -e "Intel ME will ${RED}not${NC} be cleaned. Use -m if it should be."
  156. else
  157. echo -e "Intel ME will be ${GREEN}cleaned${NC}."
  158. fi
  159. if [ ! "$lock" -gt 0 ] ; then
  160. echo -e "The flash ROM will be ${GREEN}unlocked${NC}."
  161. else
  162. echo -e "The flash ROM will be ${RED}locked${NC}."
  163. fi
  164. if [ "$me_clean" -gt 0 ] ; then
  165. if [ ! -e ${ME_CLEANER_PATH} ] ; then
  166. echo "me_cleaner not found at ${ME_CLEANER_PATH}"
  167. rm -rf ${TEMP_DIR}
  168. exit 1
  169. fi
  170. fi
  171. echo "Start reading 2 times. Please be patient..."
  172. if [[ ! "$TEMP_DIR" || ! -d "$TEMP_DIR" ]]; then
  173. echo -e "${RED}Error:${NC} Could not create temp dir"
  174. rm -rf ${TEMP_DIR}
  175. exit 1
  176. fi
  177. flashrom -p ${programmer} -c ${CHIPNAME} -r ${TEMP_DIR}/test1.rom
  178. flashrom -p ${programmer} -c ${CHIPNAME} -r ${TEMP_DIR}/test2.rom
  179. cmp --silent ${TEMP_DIR}/test1.rom ${TEMP_DIR}/test2.rom
  180. if [ "$have_backupname" -gt 0 ] ; then
  181. cp ${TEMP_DIR}/test1.rom ${BACKUPNAME}
  182. echo "current image saved as ${BACKUPNAME}"
  183. fi
  184. reference_size=8388608
  185. TEMP_SIZE=$(wc -c <"$TEMP_DIR/test1.rom")
  186. if [ ! "$reference_size" -eq "$TEMP_SIZE" ] ; then
  187. echo -e "${RED}Error:${NC} didn't read 8M. You might be at the wrong chip."
  188. rm -rf ${TEMP_DIR}
  189. exit 1
  190. fi
  191. echo -e "${GREEN}connection ok${NC}"
  192. echo "start unlocking ..."
  193. if [ "$me_clean" -gt 0 ] ; then
  194. ${ME_CLEANER_PATH} -S -O ${TEMP_DIR}/work.rom ${TEMP_DIR}/test1.rom
  195. else
  196. cp ${TEMP_DIR}/test1.rom ${TEMP_DIR}/work.rom
  197. fi
  198. if [ ! "$lock" -gt 0 ] ; then
  199. ${IFDTOOL_PATH} -u ${TEMP_DIR}/work.rom
  200. else
  201. ${IFDTOOL_PATH} -l ${TEMP_DIR}/work.rom
  202. fi
  203. if [ ! -e ${TEMP_DIR}/work.rom.new ] ; then
  204. echo -e "${RED}Error:${NC} ifdtool failed. ${TEMP_DIR}/work.rom.new not found."
  205. rm -rf ${TEMP_DIR}
  206. exit 1
  207. fi
  208. if [ "$me_clean" -gt 0 ] ; then
  209. echo -e "${GREEN}ifdtool and me_cleaner ok${NC}"
  210. else
  211. echo -e "${GREEN}ifdtool ok${NC}"
  212. fi
  213. make clean -C util/ifdtool
  214. echo "start writing..."
  215. flashrom -p ${programmer} -c ${CHIPNAME} -w ${TEMP_DIR}/work.rom.new
  216. rm -rf ${TEMP_DIR}
  217. echo -e "${GREEN}DONE${NC}"